import { join, resolve } from "path";
import makeKnex from "@aidenlx/knex";
import { fileURLToPath } from "url";

const dbPath = resolve(process.env.DB_PATH);
const bsqlite3 = fileURLToPath(
  await import.meta.resolve("@aidenlx/better-sqlite3"),
);

export const knex = makeKnex({
  client: "better-sqlite3",
  connection: {
    filename: `file:${dbPath}?mode=ro&immutable=1`,
    nativeBinding: join(bsqlite3, "../../build/Release/better_sqlite3.node"),
    readonly: true,
  },
  useNullAsDefault: true,
  // debug: true,
  pool: { min: 1, max: 1 },
});

export const getBanner = (cmd) => `
// Generated by scripts/sql-type.mjs
// Rerun \`pnpm ${cmd}\` to regenerate this file.
`;
